unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  SysUtils, FileUtil, Forms, StdCtrls, ExtCtrls, StatusUnit;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Timer1: TTimer;
    Timer2: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
  Status:=TStatus.Create(Self, 'StatusProg\StatusProg.exe', 'Temp\Status.txt');
  Status.MaxView:=1;
  Combobox1.ItemIndex:=Status.MaxView;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  Status.BringToFront;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  s:string;
  b:byte;
begin
  StatLn(2,'[Unit1.Timer1Timer] Starte Zufall-String-Ausgabe');
  s:='';
  for b:=1 to Random(50)+2 do s:=s+char(Random(23)+65);
  StatLn(Random(9),'[Unit1.Timer1Timer] sende Zufallsstring je nach Visible unterschiedlich eingerückt bzw. auch gar nicht angezeigt: '+s);
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var
  zahl1,zahl2,erg:integer;
begin
  StatLn(2,'[Unit1.Timer2Timer] Starte Zufalls-Rechnungen');
  zahl1:=Random(100);
  zahl2:=Random(10);
  case Random(4) of
    0:begin //Addition
        erg:=zahl1+zahl2;
        StatLn(3,'[Unit1.Timer2Timer] Addiere Zahl1[ '+IntToStr(zahl1)+' ] mit Zahl2[ '+IntToStr(zahl2)+' ] und bekomme das Ergebnis [ '+IntToStr(erg)+' ]');
      end;
    1:begin //Subtraktion
        erg:=zahl1-zahl2;
        StatLn(3,'[Unit1.Timer2Timer] Subtrahiere Zahl1[ '+IntToStr(zahl1)+' ] mit Zahl2[ '+IntToStr(zahl2)+' ] und bekomme das Ergebnis [ '+IntToStr(erg)+' ]');
      end;
    2:begin //Multiplikation -> Möglichkeit die Statusanzeige zu verschnellern ist, die Sichtbarkeit vor den Stringzuweisungen abzuklären:
        erg:=zahl1*zahl2;
        if Status.MaxView>2 then StatLn(3,'[Unit1.Timer2Timer] Multipliziere Zahl1[ '+IntToStr(zahl1)+' ] mit Zahl2[ '+IntToStr(zahl2)+' ] und bekomme das Ergebnis [ '+IntToStr(erg)+' ]');
      end;
    3:begin //Division -> Möglichkeit die Statusanzeige zu verschnellern ist, die Sichtbarkeit vor den Stringzuweisungen abzuklären:
        if zahl2=0 then begin
          erg:=0;
          if Status.MaxView>0 then StatLn(1,'[Unit1.Timer2Timer] Dividiere Zahl1[ '+IntToStr(zahl1)+' ] mit Zahl2[ '+IntToStr(zahl2)+' ] -> Error Division durch Null -> setze Ergebnis [ '+IntToStr(erg)+' ]');
        end else begin
          erg:=zahl1 div zahl2;
        end;
        if Status.MaxView>2 then StatLn(3,'[Unit1.Timer2Timer] Dividiere Zahl1[ '+IntToStr(zahl1)+' ] mit Zahl2[ '+IntToStr(zahl2)+' ] und bekomme das Ergebnis [ '+IntToStr(erg)+' ]');
      end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  x,y:integer;
begin
  y:=gettickcount;
  for x:=0 to 9999 do StatLn('[Unit1-Button1Click] Schreibe 10000 mal: Hallo [ '+IntToStr(x)+' ] - ohne Angabe von "Visible" - Statustexte werden nicht eingerückt!');
//  for x:=0 to 9999 do Writeln('[Unit1-Button1Click] Schreibe 10000 mal: Hallo [ '+IntToStr(x)+' ] - ohne Angabe von "Visible" - Statustexte werden nicht eingerückt!');
  Form1.Caption:=IntToStr(gettickcount-y);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if Timer1.Enabled then begin
    Timer1.Enabled:=false;
    StatLn(0,'[Unit1.Button2Click] Stoppe Timer -> zeige per Zufall verschiedene Statustexte an!');
    Button2.Caption:='Starte Zufalls-Status-Texte';
  end else begin
    Timer1.Enabled:=true;
    StatLn(0,'[Unit1.Button2Click] Starte Timer -> zeige per Zufall verschiedene Statustexte an!');
    Button2.Caption:='Stoppe Zufalls-Status-Texte';
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if Timer2.Enabled then begin
    Timer2.Enabled:=false;
    StatLn(0,'[Unit1.Button3Click] Stoppe Zufalls-Rechenoperationen');
    Button3.Caption:='Starte Zufallsrechenoperationen';
  end else begin
    Timer2.Enabled:=true;
    StatLn(0,'[Unit1.Button3Click] Starte Zufalls-Rechenoperationen');
    Button3.Caption:='Stoppe Zufallsrechenoperationen';
  end;end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  Status.MaxView:=Combobox1.ItemIndex;
end;

end.

